classification
Title: class attribute cache failure (regression)
Type: behavior Stage:
Components: Interpreter Core Versions: Python 2.6
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: gvanrossum Nosy List: _doublep, amaury.forgeotdarc, arigo, benjamin.peterson, georg.brandl, gvanrossum, jcea, rhettinger
Priority: release blocker Keywords:

Created on 2008-01-20 17:40 by _doublep, last changed 2008-10-13 11:46 by jcea. This issue is now closed.

Messages (24)
msg61316 - (view) Author: Paul Pogonyshev (_doublep) Date: 2008-01-20 17:40
I have a regression from Python 2.5 to Python SVN (would-be-2.6).  I
believe this because of class attribute caching.  The problem shown
below happens because AbstractGCProtector is an extension class.  So,
Python interpreter doesn't have a chance to notice set_default() method
below changes a class attribute.

>>> from notify.all import *
>>> original_protector = AbstractGCProtector.default
>>> new_protector = FastGCProtector ()
>>> AbstractGCProtector.default is new_protector
False
>>> AbstractGCProtector.default is original_protector
True

Please note that this a regression.  This code works as expected in 2.3
and 2.5.
msg61317 - (view) Author: Paul Pogonyshev (_doublep) Date: 2008-01-20 17:43
Eh, disregard that, I missed one line with set_default() call.  Still,
the unit test fails...
msg61318 - (view) Author: Paul Pogonyshev (_doublep) Date: 2008-01-20 17:45
OK, here it is:

>>> from notify.all import *
>>> original_protector = AbstractGCProtector.default
>>> new_protector = FastGCProtector ()
>>> AbstractGCProtector.set_default (new_protector)
>>> AbstractGCProtector.default is new_protector
False
>>> AbstractGCProtector.default is original_protector
True

It seems that this behaviour is somewhat random.  Sometimes the
False/True lines are reversed, as expected.  I.e. it seems that
attribute cache is sometimes recomputed...
msg61322 - (view) Author: Georg Brandl (georg.brandl) * (Python committer) Date: 2008-01-20 18:17
It would be very interesting to know what set_default() actually does.

IOW, without the source code of the extension module we can't do
anything about this.
msg61323 - (view) Author: Paul Pogonyshev (_doublep) Date: 2008-01-20 18:22
set_default() is a static method to set 'default'.  Because of this:

>>> AbstractGCProtector.default = 42
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
TypeError: can't set attributes of built-in/extension type
'notify.gc.AbstractGCProtector'

About source code: go to  http://download.gna.org/py-notify/  download,
unpack and do './run-tests.py' at top level.  One test fails with Python
SVN precisely because of this problem.
msg61324 - (view) Author: Georg Brandl (georg.brandl) * (Python committer) Date: 2008-01-20 18:44
I'm sorry, but I can't get this to run. With a clean 0.1.14 tarball, I get

Building extension...
running build_ext
building 'notify.gc' extension
creating build
creating build/temp.linux-i686-2.5
creating build/temp.linux-i686-2.5/notify
i686-pc-linux-gnu-gcc -pthread -fno-strict-aliasing -DNDEBUG -fPIC
-I/usr/include/python2.5 -c notify/gc.c -o
build/temp.linux-i686-2.5/notify/gc.o
creating build/lib.linux-i686-2.5
creating build/lib.linux-i686-2.5/notify
i686-pc-linux-gnu-gcc -pthread -shared
build/temp.linux-i686-2.5/notify/gc.o -L/usr/lib -lpython2.5 -o
build/lib.linux-i686-2.5/notify/gc.so
[1]    28189 segmentation fault  ~/devel/python/python run-tests.py

when running with a trunk python (note the "2.5" in the paths...)

When I build the extension manually and comment out the building command
in run-tests.py, I get


Note that most of the time is spent in gc.collect() calls, not in this
package

..............................................................Fatal
Python error: Objects/classobject.c:2311 object at 0x82dd2bc has
negative ref count -606348326
[1]    28540 abort      ~/devel/python/python run-tests.py
msg61325 - (view) Author: Paul Pogonyshev (_doublep) Date: 2008-01-20 18:50
Weird.  Does it even run with a stable Python (not trunk)?
msg61327 - (view) Author: Georg Brandl (georg.brandl) * (Python committer) Date: 2008-01-20 18:51
Yes, runs fine with 2.5.
msg61328 - (view) Author: Paul Pogonyshev (_doublep) Date: 2008-01-20 18:54
Can you run the pasted script (from the third comment) manually then? 
The crash might be related to the bug in question.
msg61342 - (view) Author: Georg Brandl (georg.brandl) * (Python committer) Date: 2008-01-20 19:24
I've now built my trunk python without debugging enabled, and can
reproduce your problem.

Armin: the extension module directly modifies an extension type's
tp_dict -- what should it do instead to make the cache happy?
msg61363 - (view) Author: Paul Pogonyshev (_doublep) Date: 2008-01-20 21:54
Even if there is an easy workaround for the extension (or even a fix, if
modifying 'tp_dict' is not legal), I don't think it would be acceptable
to make a backward-incompatible change in 2.6.  I mean, sure Py-notify
is by no means a widely-used library, but can you guarantee that no
other extension will get broken?
msg61364 - (view) Author: Amaury Forgeot d'Arc (amaury.forgeotdarc) * (Python committer) Date: 2008-01-20 22:02
The issue seems similar to the one we had in ctypes when the method
attribute cache was implemented. 

Ctypes was corrected in r59943. Maybe similar changes are needed for
this extension.

For example,
  PyDict_SetItemString (AbstractGCProtector_Type.tp_dict, "default",
new_protector)
should be modified like this:
  PyObject_SetAttr(AbstractGCProtector_Type, "default", new_protector)
msg61365 - (view) Author: Paul Pogonyshev (_doublep) Date: 2008-01-20 22:07
It doesn't help:

ERROR: test_default_property (test._gc.AbstractGCProtectorTestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/home/paul/notify/test/_gc.py", line 59, in test_default_property
    AbstractGCProtector.set_default (original_protector)
TypeError: can't set attributes of built-in/extension type
'notify.gc.AbstractGCProtector'

With this code:

  if (PyObject_SetAttrString ((PyObject *) &AbstractGCProtector_Type,
"default", new_protector)
      == -1)
    return NULL;
msg61381 - (view) Author: Armin Rigo (arigo) * (Python committer) Date: 2008-01-21 10:16
I don't see in general how the patch can be kept compatible with
extension modules that change the tp_dict of arbitrary types.  All I can
think of is a way to be safe against extension modules that only change
the tp_dict of their own non-heap types (i.e. types defined in C).  The
method cache is disabled for types that don't have the
Py_TPFLAGS_HAVE_VERSION_TAG flag; so if we would leave this flag out of
Py_TPFLAGS_DEFAULT, non-heap types from extension modules would by
default not use the cache.

I'm not sure about the API for this.  Would we then need to put
Py_TPFLAGS_HAVE_VERSION_TAG explicitly on all core types?  And about how
to change tp_dict in a way that makes the cache happy - do we need to
turn type_modified() into a public API?

All in all, the lack of abstraction of the C API might kill the idea of
this patch for CPython.
msg61415 - (view) Author: Georg Brandl (georg.brandl) * (Python committer) Date: 2008-01-21 16:58
We can of course add something like in #1229239, which allows type
attributes to be set with PyObject_SetAttr, thereby updating the cache.
msg61447 - (view) Author: Paul Pogonyshev (_doublep) Date: 2008-01-21 20:53
I personally think that this bug is a showstopper for the caching patch
in 2.6.  Well, the problem can be deemed insignificant, but it is sure a
break of backward compatibility and, worse yet, it results in _very_
obscure fails.  Even if type dictionary changes are not all that common,
I'm sure there are extensions out there that do it.

For Py3k things can be different.  I'm not sure what would be the best
way, but at least Py3k is not required to be compatible with 2.x in all
aspects.
msg70483 - (view) Author: Benjamin Peterson (benjamin.peterson) * (Python committer) Date: 2008-07-31 02:18
Ping
msg70490 - (view) Author: Raymond Hettinger (rhettinger) * (Python committer) Date: 2008-07-31 07:57
Guido, what say you, live with it, revert it, or apply 
Py_TPFLAGS_HAVE_VERSION_TAG to all core types?
msg70523 - (view) Author: Armin Rigo (arigo) * (Python committer) Date: 2008-07-31 16:07
Maybe there is a better solution along the following line: conditionally
define Py_TPFLAGS_DEFAULT so that when compiling the Python core it
includes the Py_TPFLAGS_HAVE_VERSION_TAG, but when compiling extension
modules it does not.  This should ensure compatibility with many
existing extension modules.  (It would still break if they play tricks
like modifying the tp_dict of types other than their own.)

In addition, to support the method cache in newer C extension modules:

* C types defined by C extension modules can include the
Py_TPFLAGS_HAVE_VERSION_TAG explicitly to enable the cache;

* new C API functions should be introduced to give an official way to
access the tp_dict of a type, e.g. PyType_{Get,Set,Del}DictItemString().
msg71466 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2008-08-19 19:16
I like Armin's latest proposal: have Py_TPFLAGS_DEFAULT include
Py_TPFLAGS_HAVE_VERSION_TAG when compiling the core only.  ISTR there's
a way to do this, but I can't find it right now.
msg71468 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2008-08-19 19:25
Please review the patch here: http://codereview.appspot.com/3005
msg71476 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2008-08-19 20:14
Submitted as r65874.

I will block this for 3.0; 3.0 extensions that want to mess with tp_dict
must explicitly disable this flag.
msg71479 - (view) Author: Benjamin Peterson (benjamin.peterson) * (Python committer) Date: 2008-08-19 20:44
Do we want a test?
msg71484 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2008-08-19 21:06
Sure, go right ahead.
History
Date User Action Args
2008-10-13 11:46:22jceasetnosy: + jcea
2008-08-19 21:06:14gvanrossumsetmessages: + msg71484
2008-08-19 20:44:16benjamin.petersonsetmessages: + msg71479
2008-08-19 20:14:29gvanrossumsetstatus: open -> closed
resolution: fixed
messages: + msg71476
2008-08-19 19:25:50gvanrossumsetmessages: + msg71468
2008-08-19 19:16:54gvanrossumsetmessages: + msg71466
2008-07-31 16:07:44arigosetmessages: + msg70523
2008-07-31 07:57:45rhettingersetassignee: arigo -> gvanrossum
messages: + msg70490
nosy: + rhettinger, gvanrossum
2008-07-31 02:18:14benjamin.petersonsetpriority: critical -> release blocker
nosy: + benjamin.peterson
messages: + msg70483
2008-01-21 20:53:31_doublepsetmessages: + msg61447
2008-01-21 16:58:39georg.brandlsetmessages: + msg61415
2008-01-21 15:10:31georg.brandlsetpriority: critical
2008-01-21 10:16:24arigosetmessages: + msg61381
2008-01-20 22:07:18_doublepsetmessages: + msg61365
2008-01-20 22:02:18amaury.forgeotdarcsetnosy: + amaury.forgeotdarc
messages: + msg61364
2008-01-20 21:54:30_doublepsetmessages: + msg61363
2008-01-20 19:24:40georg.brandlsetassignee: arigo
messages: + msg61342
nosy: + arigo
2008-01-20 18:54:59_doublepsetmessages: + msg61328
2008-01-20 18:51:19georg.brandlsetmessages: + msg61327
2008-01-20 18:50:21_doublepsetmessages: + msg61325
2008-01-20 18:44:19georg.brandlsetmessages: + msg61324
2008-01-20 18:22:53_doublepsetmessages: + msg61323
2008-01-20 18:17:16georg.brandlsetnosy: + georg.brandl
messages: + msg61322
2008-01-20 17:45:31_doublepsetmessages: + msg61318
2008-01-20 17:43:36_doublepsetmessages: + msg61317
2008-01-20 17:40:57_doublepcreate